#include <stdio.h>
#include <string.h>
#include "cui.h"
#include "esc.h"
#include "handler.h"
#include "label.h"
#include "button.h"
#include "dialog.h"

int
joke_hdr(cui obj, int evt, int val, void *prm)
{
	cui lb = (cui)prm, b2 = lb->children, b1 = b2->next;
	char *s = cui_button_str_get(obj);

	if(strcmp(s, "reboot") == 0 || strcmp(s, "power off") == 0){
		cui_label_str_set(lb, "It's a joke");
		cui_button_str_set(b1, "sorry");
		cui_x_set(b1, lb->w + 1);
		cui_hide(b2);
		cui_focus_set(b1);
		cui_w_set(lb, b1->x + b1->w);		
	}else{
		cui_hide(lb);	
		cui_focus_set(NULL);
		cui_draw(lb->parent);
		cui_quit();
	}
	return TRUE;
}

cui
joke_new(cui parent, int x, int y)
{
	cui lb = cui_label_new(parent, x, y, "system panic!");
	cui b1 = cui_button_new(lb, lb->w + 1, 0, "reboot");
	cui b2 = cui_button_new(lb, b1->x + b1->w + 1, 0, "power off");
	cui_w_set(lb, b2->x + b2->w);
	cui_bind(b1, CUI_EVT_BUTTON, joke_hdr, lb);
	cui_bind(b2, CUI_EVT_BUTTON, joke_hdr, lb);
	return lb;
}

int
my_hdr(cui obj, int evt, int val, void *prm)
{
	cui joke;
	cui_simple_dialog p = (cui_simple_dialog)prm;
	cui_label_str_set(p->label, "Realy ?");
	cui_button_str_set(p->btn1, "Yes");
	cui_button_str_set(p->btn2, "No");
	cui_unbind(obj, CUI_EVT_BUTTON, my_hdr);
	joke = joke_new(((cui)p)->parent->parent->parent, 0, 4);
	cui_main(joke, joke->children->next);
	cui_del(joke);
	cui_free(joke);
	return TRUE;
}

int
my_hdr2(cui obj, int evt, int val, void *prm)
{
	cui dlg = (cui)prm;
	if(cui_is_visible(dlg)) cui_hide(dlg);
	else cui_show(dlg);
	cui_button_str_set(obj, cui_is_visible(dlg) ? "Hide Dialog" : "Show Dialog");
	return TRUE;
}

int
mv_hdr(cui obj, int evt, int val, void *prm)
{
	static char buf[16];

	cui_xywh_set(obj, obj->x, obj->y + 1, obj->w, obj->h);
	sprintf(buf, "%d", cui_gy(obj));
	cui_label_str_set((cui)prm, buf);
	return TRUE;
}

int
arrow_hdr(cui obj, int evt, int val, void *prm)
{
	cui big = (cui)prm;
	char *s = cui_button_str_get(obj);
	int x = big->x, y = big->y;

	if(strcmp(s, "L") == 0) x++; 
	else if (strcmp(s, "R") == 0) x--; 
	else if (strcmp(s, "U") == 0) y++; 
	else if (strcmp(s, "D") == 0) y--; 
	cui_xywh_set(big, x, y, big->w, big->h);
	return TRUE;
}

cui
arrow_new(cui parent, int x, int y, void *prm)
{
	cui base = cui_base_new(parent, x, y, 0, 0);
	cui al = cui_button_new(base, 0, 1, "L");
	cui ad = cui_button_new(base, al->x + al->w, 1, "D");
	cui ar = cui_button_new(base, ad->x + ad->w, 1, "R");
	cui au = cui_button_new(base, ad->x, 0, "U");
	base->w = ar->x + ar->w;
	base->h = 2;
	cui_bind(al, CUI_EVT_BUTTON, arrow_hdr, prm);
	cui_bind(ad, CUI_EVT_BUTTON, arrow_hdr, prm);
	cui_bind(ar, CUI_EVT_BUTTON, arrow_hdr, prm);
	cui_bind(au, CUI_EVT_BUTTON, arrow_hdr, prm);
	return base;
}

cui
big_new(cui parent, int x, int y, cui_simple_dialog *res_dlg)
{
	cui base = cui_panel_new(parent, x, y, 0, 0);
	cui dlg = cui_simple_dialog_new(base, 0, 0, "Are you sure ?", "OK", "Cancel");
	cui_simple_dialog p = (cui_simple_dialog)dlg;	
	cui_simple_dialog_new(base, dlg->x + dlg->w, dlg->y, "Continue ?", "Yes", "No");
	cui_simple_dialog_new(base, dlg->x, dlg->y + dlg->h, "How are you ?", "^_^", "T_T");
	cui_simple_dialog_new(base, dlg->x + dlg->w, dlg->y + dlg->h, "(A1)     (B2)", "C3", "D4");
	base->w = dlg->w * 2;
	base->h = dlg->h * 2;
	cui_bind(p->btn1, CUI_EVT_BUTTON, my_hdr, p);
	*res_dlg = p;
	return base;
}

int
main()
{
	cui base = cui_panel_new(NULL, 0, 0, 40, 20);
	cui btn = cui_button_new(base, 2, 1, "Show Dialog");
	cui mv_btn = cui_button_new(base, btn->x + btn->w + 2, btn->y, "move");
	cui mv_lb = cui_label_new(base, mv_btn->x + mv_btn->w + 2, mv_btn->y, "");

	cui_simple_dialog p;
	cui small = cui_panel_new(base, 2, 3, base->w - (2 * 2), base->h - (3 + 1));
	cui small2 = cui_base_new(small, 1, 1, small->w - 2, small->h - 2);
	cui big = big_new(small2, 0, 0, &p);

	arrow_new(base, mv_lb->x + mv_lb->w + 2, mv_lb->y, big);

	small->flags |= CUI_FLG_HIDE;
	cui_bind(btn, CUI_EVT_BUTTON, my_hdr2, small);
	cui_bind(mv_btn, CUI_EVT_BUTTON, mv_hdr, mv_lb);

	cui_main(base, NULL);
	printf("result %s\n", p->btn_result);
	cui_free(base);
	return 0;
}

/* EOF */
