#include "key.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <termios.h>

#define KEY_FD	0

int cui_key_cnt = 0;
static struct termios bak;

void
cui_key_enter(void)
{
	struct termios raw;

	if(cui_key_cnt++ > 0) return;
	tcgetattr(KEY_FD, &bak);
	cfmakeraw(&raw);
	raw.c_lflag &= ~FLUSHO;
	tcsetattr(KEY_FD, TCSANOW, &raw);
}

void
cui_key_exit(void)
{
	if(--cui_key_cnt > 0) return;
	tcsetattr(KEY_FD, TCSANOW, &bak);
}

int
cui_key_get(void)
{
	fd_set rfs;
	struct timeval tm;
	int ret;
	unsigned char uc;

	FD_ZERO(&rfs);
	FD_SET(KEY_FD, &rfs);
	tm.tv_sec = 0;
	tm.tv_usec = 100*1000;
	ret = select(KEY_FD+1, &rfs, NULL, NULL, &tm);
	if(ret <= 0) return 0;

	if(read(KEY_FD, &uc, 1) != 1) return 0;
	return uc;
}

int
cui_key_get2(void)
{
	int k, k2, k3;

	k= cui_key_get();
	if(k == 0x7f) return CUI_KEY_BS;
	if(k == CUI_KEY_ESC){
		k2 = cui_key_get();		
		if(k2 == '['){
			k3 = cui_key_get();
			switch(k3){
			case 'A': return CUI_KEY_UP;
			case 'B': return CUI_KEY_DOWN;
			case 'C': return CUI_KEY_RIGHT;
			case 'D': return CUI_KEY_LEFT;
			}
		}
	}
	return k;
}

/* EOF */
