#include "label.h"
#include "esc.h"
#include "handler.h"
#include <stdio.h>
#include <string.h>

cui
cui_label_new(cui parent, int x, int y, char *s)
{
	cui obj = cui_alloc(sizeof(struct cui_label));
	cui_label_init(obj, parent, x, y, s);
	return obj;
}

int
cui_label_hdr(cui obj, int evt, int val, void *prm)
{
	cui_label p = (cui_label)obj;
	cui_draw_str(obj, 0, 0, cui_label_str_get(obj), p->attr);
	return TRUE;
}

void
cui_label_init(cui obj, cui parent, int x, int y, char *s)
{
	cui_label p = (cui_label)obj;
	cui_base_init(obj, parent, x, y, strlen(s), 1);
	p->s = s;	
	p->attr = CUI_ATTR_NORMAL;
	cui_bind(obj, CUI_EVT_DRAW, cui_label_hdr, NULL);
}

char *
cui_label_str_get(cui obj)
{
	cui_label p = (cui_label)obj;
	return p->s;
}

void
cui_label_str_set(cui obj, char *s)
{
	cui_label p = (cui_label)obj;
	int visi = cui_is_visible(obj);
	if(visi) cui_hide(obj);
	p->s = s;
	obj->w = strlen(s);
	if(visi) cui_show(obj);
}

void
cui_label_attr_set(cui obj, int attr)
{
	cui_label p = (cui_label)obj;
	p->attr = attr;
	cui_draw(obj);
}

/* EOF */
